searchNodes=[{"doc":"Event that triggers seeking or insertion to a file in Membrane.File.Sink . inspect(__MODULE__) allows to control behaviour of Membrane.File.Sink when writing to a file by seeking to given position (relative to beginning of file, current position or end of file). All buffers that arrive after that event are being written starting from the position . If overwriting isn't the desired behaviour, one can set insert? flag to true . This will trigger splitting the file into two parts containing bytes before and after position . All buffers following such an event will be appended to the first part. Inserting has considerable performance impact, especially if done repeatedly, so it should be used only as a fallback for variable-length data. For all other cases, one can fill unknown bytes with eg. 0 s and simply overwrite them later.","ref":"Membrane.File.SeekEvent.html","title":"Membrane.File.SeekEvent","type":"module"},{"doc":"","ref":"Membrane.File.SeekEvent.html#t:offset_t/0","title":"Membrane.File.SeekEvent.offset_t/0","type":"type"},{"doc":"","ref":"Membrane.File.SeekEvent.html#t:position_t/0","title":"Membrane.File.SeekEvent.position_t/0","type":"type"},{"doc":"","ref":"Membrane.File.SeekEvent.html#t:t/0","title":"Membrane.File.SeekEvent.t/0","type":"type"},{"doc":"Element that creates a file and stores incoming buffers there (in binary format). When Membrane.File.SeekEvent is received, the element starts writing buffers starting from position . By default, it overwrites previously stored bytes. You can set insert? field of the event to true to start inserting new buffers without overwriting previous ones. Please note, that inserting requires rewriting the file, what negatively impacts performance. For more information refer to Membrane.File.SeekEvent moduledoc. Element options Passed via struct Membrane.File.Sink.t/0 location Path . t ( ) Required Path of the output file Pads :input Availability :always Caps :any Demand mode :manual Demand unit :buffers Direction :input Mode :pull Name :input","ref":"Membrane.File.Sink.html","title":"Membrane.File.Sink","type":"module"},{"doc":"Returns pads descriptions for Membrane.File.Sink","ref":"Membrane.File.Sink.html#membrane_pads/0","title":"Membrane.File.Sink.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.File.Sink.html#options/0","title":"Membrane.File.Sink.options/0","type":"function"},{"doc":"Struct containing options for Membrane.File.Sink","ref":"Membrane.File.Sink.html#t:t/0","title":"Membrane.File.Sink.t/0","type":"type"},{"doc":"Element that writes buffers to a set of files. File is switched on event. Files are named according to naming_fun passed in options. This function receives sequential number of file and should return string. It defaults to path/to/file0.ext , path/to/file1.ext , ... The event type, which starts writing to a next file is passed by split_event option. It defaults to Membrane.File.SplitEvent . Element options Passed via struct Membrane.File.Sink.Multi.t/0 location Path . t ( ) Required Base path to the file, will be passed to the naming function extension String . t ( ) Default value: &quot;&quot; Extension of the file, should be preceeded with dot (.). It is passed to the naming function. naming_fun ( Path . t ( ) , non_neg_integer , String . t ( ) -&gt; Path . t ( ) ) Default value: &amp;Membrane.File.Sink.Multi.default_naming_fun/3 Function accepting base path, sequential number and file extension, and returning file path as a string. Default one generates path/to/file0.ext, path/to/file1.ext, ... split_event Membrane.Event . t ( ) Default value: Membrane.File.SplitEvent Event causing switching to a new file Pads :input Availability :always Caps :any Demand mode :manual Demand unit :buffers Direction :input Mode :pull Name :input","ref":"Membrane.File.Sink.Multi.html","title":"Membrane.File.Sink.Multi","type":"module"},{"doc":"","ref":"Membrane.File.Sink.Multi.html#default_naming_fun/3","title":"Membrane.File.Sink.Multi.default_naming_fun/3","type":"function"},{"doc":"Returns pads descriptions for Membrane.File.Sink.Multi","ref":"Membrane.File.Sink.Multi.html#membrane_pads/0","title":"Membrane.File.Sink.Multi.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.File.Sink.Multi.html#options/0","title":"Membrane.File.Sink.Multi.options/0","type":"function"},{"doc":"Struct containing options for Membrane.File.Sink.Multi","ref":"Membrane.File.Sink.Multi.html#t:t/0","title":"Membrane.File.Sink.Multi.t/0","type":"type"},{"doc":"Element that reads chunks of data from given file and sends them as buffers through the output pad. Element options Passed via struct Membrane.File.Source.t/0 location Path . t ( ) Required Path to the file chunk_size pos_integer ( ) Default value: 2048 Size of chunks being read Pads :output Availability :always Caps :any Demand mode :manual Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.File.Source.html","title":"Membrane.File.Source","type":"module"},{"doc":"Returns pads descriptions for Membrane.File.Source","ref":"Membrane.File.Source.html#membrane_pads/0","title":"Membrane.File.Source.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.File.Source.html#options/0","title":"Membrane.File.Source.options/0","type":"function"},{"doc":"Struct containing options for Membrane.File.Source","ref":"Membrane.File.Source.html#t:t/0","title":"Membrane.File.Source.t/0","type":"type"},{"doc":"Default event that closes current and opens new file in Membrane.File.Sink.Multi .","ref":"Membrane.File.SplitEvent.html","title":"Membrane.File.SplitEvent","type":"module"},{"doc":"Membrane plugin for reading and writing to files. It is part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane File plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_file_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_file_plugin , &quot;~&gt; 0.9.0&quot; } ] end","ref":"readme.html#installation","title":"Membrane File plugin - Installation","type":"extras"},{"doc":"Playing below pipeline should copy /etc/passwd to ./test : defmodule FileExamplePipeline do use Membrane.Pipeline @doc false @impl true def handle_init ( _ ) do children = [ file_src : % Membrane.File.Source { location : &quot;/etc/passwd&quot; } , file_sink : % Membrane.File.Sink { location : &quot;./test&quot; } , ] links = [ link ( :file_src ) |&gt; to ( :file_sink ) ] { { :ok , spec : % ParentSpec { children : children , links : links } } , %{ } } end end","ref":"readme.html#sample-usage","title":"Membrane File plugin - Sample usage","type":"extras"},{"doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane File plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]